/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the CannedResponseStartRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CannedResponseStartRequest{}

// CannedResponseStartRequest struct for CannedResponseStartRequest
type CannedResponseStartRequest struct {
	ConversationId string `json:"conversation_id"`
	Language string `json:"language"`
	Params map[string]interface{} `json:"params,omitempty"`
}

// NewCannedResponseStartRequest instantiates a new CannedResponseStartRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCannedResponseStartRequest(conversationId string, language string) *CannedResponseStartRequest {
	this := CannedResponseStartRequest{}
	this.ConversationId = conversationId
	this.Language = language
	return &this
}

// NewCannedResponseStartRequestWithDefaults instantiates a new CannedResponseStartRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCannedResponseStartRequestWithDefaults() *CannedResponseStartRequest {
	this := CannedResponseStartRequest{}
	return &this
}

// GetConversationId returns the ConversationId field value
func (o *CannedResponseStartRequest) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *CannedResponseStartRequest) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *CannedResponseStartRequest) SetConversationId(v string) {
	o.ConversationId = v
}

// GetLanguage returns the Language field value
func (o *CannedResponseStartRequest) GetLanguage() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Language
}

// GetLanguageOk returns a tuple with the Language field value
// and a boolean to check if the value has been set.
func (o *CannedResponseStartRequest) GetLanguageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Language, true
}

// SetLanguage sets field value
func (o *CannedResponseStartRequest) SetLanguage(v string) {
	o.Language = v
}

// GetParams returns the Params field value if set, zero value otherwise.
func (o *CannedResponseStartRequest) GetParams() map[string]interface{} {
	if o == nil || IsNil(o.Params) {
		var ret map[string]interface{}
		return ret
	}
	return o.Params
}

// GetParamsOk returns a tuple with the Params field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CannedResponseStartRequest) GetParamsOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Params) {
		return map[string]interface{}{}, false
	}
	return o.Params, true
}

// HasParams returns a boolean if a field has been set.
func (o *CannedResponseStartRequest) HasParams() bool {
	if o != nil && !IsNil(o.Params) {
		return true
	}

	return false
}

// SetParams gets a reference to the given map[string]interface{} and assigns it to the Params field.
func (o *CannedResponseStartRequest) SetParams(v map[string]interface{}) {
	o.Params = v
}

func (o CannedResponseStartRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CannedResponseStartRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["conversation_id"] = o.ConversationId
	toSerialize["language"] = o.Language
	if !IsNil(o.Params) {
		toSerialize["params"] = o.Params
	}
	return toSerialize, nil
}

type NullableCannedResponseStartRequest struct {
	value *CannedResponseStartRequest
	isSet bool
}

func (v NullableCannedResponseStartRequest) Get() *CannedResponseStartRequest {
	return v.value
}

func (v *NullableCannedResponseStartRequest) Set(val *CannedResponseStartRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCannedResponseStartRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCannedResponseStartRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCannedResponseStartRequest(val *CannedResponseStartRequest) *NullableCannedResponseStartRequest {
	return &NullableCannedResponseStartRequest{value: val, isSet: true}
}

func (v NullableCannedResponseStartRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCannedResponseStartRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


